*G:\AGL\HMG\3.4.4\Build QDIP_AGL
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
//  Quick Digital Image Processing  By AndyGlezL 	
//  01/NOV/2020		ANDRÉS GONZÁLEZ LÓPEZ		andyglezl@hotmail.com
//  DESDE GUADALAJARA, JALISCO. MÉXICO.
//  https://www.hmgforum.com/viewtopic.php?f=9&t=6668
//
//	Tomando como base: \HMG\3.4.4\SAMPLES\BosTaurus\Demo10.prg del Dr. Claudio Soto
//  Based on: \HMG\3.4.4\SAMPLES\BosTaurus\Demo10.prg by Dr. Claudio Soto
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/


/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
//  								"TODO ES POSIBLE DE MEJORAR"
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/


//  PENDIENTES...
//  * Como tomar del Portapapeles y pegar aquí
//  * Como hacer DRAG&DROP hacia este programa
//  * Como crear TABS para tener varios archivos abiertos
//  * Como copiar y pegar dentro de los TABS abiertos
//  * En ocasiones como que hay problemas de memoria y da error. (La imagen ya no se despliega y ya no se pueden leer desde archivo)
//  * No pude crearlo con WINDOW PANEL (aunque no le dediqué mucho tiempo...)
//  * El STATUSBAR queda dentro de la Imagen y parpadea. (se ocupa para desplegar datos de la Imagen)
//  * Cambiar el tamaño de la imagen para PREVIEW dentro de la pantalla si la imagen es más grande
//  * Cambiar el tamaño de la imagen para GUARDAR (Rezise)
//  * Poner ICONO al .exe
//  * Como tener fijos los SPINNERS al recorrer la Imagen
//  * Pasar los SPINNER a forma Horizontal (abajo del Menú)
//  * Manejar otros tipos de Imagenes ?  ( BMP, TIFF, etc.)
//  * Configurar con diferentes Idiomas
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/


/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
#include "hmg.ch"

#define ProgAuthor                 "[ Quick Digital Image Processing   V 0.6     By AndyGlezL ]"

// Definiciones de Bos Taurus
#define BT_Blur(nWeight)           {  0,  2,  0,  2,  nWeight,  2,  0,  2,  0,   nWeight  +8,     0 } // Blur (Borrado)
#define BT_GaussianBlur(nWeight)   {  1,  2,  1,  2,  nWeight,  2,  1,  2,  1,   nWeight +12,     0 } // Gaussian Blur (Borrado Gaussiano)
#define BT_Sharpen(nWeight)        {  0, -1,  0, -1,  nWeight, -1,  0, -1,  0,   nWeight  -4,     0 } // Sharpen (Nitidez)
#define BT_Smooth(nWeight)         {  1,  1,  1,  1,  nWeight,  1,  1,  1,  1,   nWeight  +8,     0 } // Smooth (Suavizado)
#define BT_GaussianSmooth(nWeight) {  0,  1,  0,  1,  nWeight,  1,  0,  1,  0,   nWeight  +4,     0 } // Gaussian Smooth (Suavizado Gaussiano)
#define BT_MeanRemoval(nWeight)    { -1, -1, -1, -1,  nWeight, -1, -1, -1, -1,   nWeight  -8,     0 } // Mean Removal  
#define BT_EdgeDetection1          {  1,  1,  1,  1,    -8,     1,  1,  1,  1,             0,     0 } // Detects Edges in All Directions
#define BT_EdgeDetection2          {  1,  1,  1,  1,    -7,     1,  1,  1,  1,             1,     0 } // Detects Edges Execessively

#define CRLF      HB_OsNewLine()
#define CRLF2     CRLF+CRLF

// Para recorrer con teclado en ventanas virtuales
#define WM_HSCROLL    276  // con Pgup y PgDw
#define WM_VSCROLL    277  // con PgLeft y PgRight
#define SB_HORZ         0
#define SB_VERT         1
#define SB_PAGEUP       2
#define SB_PAGEDOWN     3
#define SB_PAGELEFT     2
#define SB_PAGERIGHT    3
#define SB_LEFT         6
#define SB_RIGHT        7
#define SB_BOTTOM       7
#define SB_TOP          6

/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION MAIN()
	LOCAL aFdoPant := { 50, 50, 50 }	// GRIS OBSCURO
	PUBLIC hBitmap_Source := 0, hBitmap := 0
	PUBLIC nRed := 0, nGreen := 0, nBlue := 0, nColGray := 0, nIncrement := 0, nBright := 0, nContr := 0
	PUBLIC nRedGamma := 1, nGreenGamma := 1, nBlueGamma := 1, weight := 0
	PUBLIC cPathIni := HB_CurDrive()+':\'+CurDir()+'\', cFileName := ""
	
	nAncPant := GetDesktopWidth()
	nAltPant := GetDesktopHeight()

	// SET AUTOSCROLL ON / OFF	// DA LO MISMO ESTANDO EN ON u OFF, INCLUSO SI NO ESTÁ...   
	// (Porqué al oprimir el botón derecho del ratón en la Imagen se activa el SCROLL ???)
	
	DEFINE WINDOW Win1 AT 0,0 WIDTH nAncPant HEIGHT nAltPant TITLE ProgAuthor NOSIZE NOCAPTION MAIN ;
			BACKCOLOR aFdoPant VIRTUAL WIDTH 3000 VIRTUAL HEIGHT 2500 ON INIT ON_INIT() ON RELEASE ON_RELEASE() ON PAINT ON_PAINT()
			// Y LAS IMAGENES QUE SON MÁS GRANDES ???

			//-------  Para recorrer la imagen por teclado con CONTROL+LEFT, CONTROL+RIGHT, CONTROL+UP, CONTROL+DOWN   --------------------
			NewStep := 100
			hWnd := GetFormHandle( "Win1" )
			ON KEY CONTROL+LEFT  OF Win1 ACTION { || SetScrollPos( hWnd, SB_HORZ, GetScrollPos( hWnd, SB_HORZ ) - NewStep -20, .T. ), ;
													 SendMessage( hWnd, WM_HSCROLL , SB_PAGELEFT,    0 ) }
			ON KEY CONTROL+RIGHT OF Win1 ACTION { || SetScrollPos( hWnd, SB_HORZ, GetScrollPos( hWnd, SB_HORZ ) + NewStep -20, .T.), ;
													 SendMessage( hWnd, WM_HSCROLL , SB_PAGERIGHT , 0 ) }
			ON KEY CONTROL+UP    OF Win1 ACTION { || SetScrollPos( hWnd, SB_VERT, GetScrollPos( hWnd, SB_VERT ) - NewStep -20, .T. ), ;
													 SendMessage( hWnd, WM_VSCROLL , SB_PAGEUP,    0 ) }
			ON KEY CONTROL+DOWN  OF Win1 ACTION { || SetScrollPos( hWnd, SB_VERT, GetScrollPos( hWnd, SB_VERT ) + NewStep -20, .T.), ;
													 SendMessage( hWnd, WM_VSCROLL , SB_PAGEDOWN , 0 ) }		//	*CONTROL+END, CONTROL+HOME
			//---------------------------------------------------------------------------------------------------------------
			
			// PORQUÉ LA PANEL WINDOW SE MUEVE CON LA IMAGEN ???
			*DEFINE WINDOW WinPan1 ROW 025 COL 001 WIDTH nAncPant-2 HEIGHT 26 WINDOWTYPE PANEL BACKCOLOR { 017, 032, 045 }
			*	// Poner Aquí los Controles de forma Horizontal...
			*	// PRUEBA PARA CAMBIAR DE LUGAR LOS CONTROLES DE FORMA HORIZONTAL
			*	@ 003 , 555 LABEL LB_Ajustes   VALUE "AJUSTES: " WIDTH 50 HEIGHT 14 FONT "Calibri" SIZE 9 BACKCOLOR GRAY FONTCOLOR WHITE
			*	@ 001 , 605 SPINNER xSPNColGray OF Win1 RANGE 0 , 100 VALUE 0 WIDTH 45 HEIGHT 17 FONT "Calibri" SIZE 9 TOOLTIP "SATURATION" ;
			*				ITALIC	BACKCOLOR GRAY FONTCOLOR WHITE ON CHANGE { nColGray := Win1.xSPNColGray.Value, ChangeImage( ) } INCREMENT 5
			*	@ 002 , 650 LABEL xLB_Gray  VALUE " Ø" WIDTH 11 HEIGHT 15 FONT "Calibri" SIZE 8 ACTION Win1.xSPNColGray.Value := 0
			*	@ 001 , 665 SPINNER xSPNRed   OF Win1 RANGE -255 , 255 VALUE 0 WIDTH 45 HEIGHT 17 FONT "Calibri" SIZE 9 TOOLTIP "RED" ;
			*				ITALIC	BACKCOLOR RED FONTCOLOR WHITE ON CHANGE { nRed   := Win1.xSPNRed.Value, ChangeImage( ) } INCREMENT 5
			*	@ 002 , 710 LABEL xLB_Red   VALUE " Ø" WIDTH 11 HEIGHT 15 FONT "Calibri" SIZE 8 ACTION Win1.xSPNRed.Value := 0
			*	@ 001 , 725 SPINNER xSPNGreen OF Win1 RANGE -255 , 255 VALUE 0 WIDTH 45 HEIGHT 17 FONT "Calibri" SIZE 9 TOOLTIP "GREEN"  ;
			*				ITALIC	BACKCOLOR GREEN FONTCOLOR WHITE ON CHANGE { nGreen := Win1.xSPNGreen.Value, ChangeImage( ) } INCREMENT 5
			*	@ 002 , 770 LABEL xLB_Green VALUE " Ø" WIDTH 11 HEIGHT 15 FONT "Calibri" SIZE 8 ACTION Win1.xSPNGreen.Value := 0
			*	@ 001 , 785 SPINNER xSPNBlue  OF Win1 RANGE -255 , 255 VALUE 0 WIDTH 45 HEIGHT 17 FONT "Calibri" SIZE 9 TOOLTIP "BLUE"  ;
			*				ITALIC	BACKCOLOR BLUE FONTCOLOR WHITE ON CHANGE { nBlue  := Win1.xSPNBlue.Value, ChangeImage( ) }  INCREMENT 5
			*	@ 002 , 830 LABEL xLB_Blue  VALUE " Ø" WIDTH 11 HEIGHT 15 FONT "Calibri" SIZE 8 ACTION Win1.xSPNBlue.Value := 0
			*	
			*	@ 001 , 845 SPINNER xSPNBright  OF Win1 RANGE -255 , 255 VALUE 0 WIDTH 45 HEIGHT 17 FONT "Calibri" SIZE 9 TOOLTIP "BRIGHTNESS"  ;
			*				ITALIC	BACKCOLOR WHITE FONTCOLOR BLACK ON CHANGE { nBright  := Win1.xSPNBright.Value, ChangeImage( ) }  INCREMENT 5
			*	@ 002 , 890 LABEL LB_xBright VALUE " Ø" WIDTH 11 HEIGHT 15 FONT "Calibri" SIZE 8 ACTION Win1.xSPNBright.Value := 0								
			*	@ 001 , 905 SPINNER xSPNContr  OF Win1 RANGE 0 , 135 VALUE 0 WIDTH 45 HEIGHT 17 FONT "Calibri" SIZE 9 TOOLTIP "CONTRAST"  ;
			*				ITALIC	BACKCOLOR BLACK FONTCOLOR WHITE ON CHANGE { nContr  := Win1.xSPNContr.Value, ChangeImage( ) }  INCREMENT 5
			*	@ 002 , 950 LABEL xLB_Contr VALUE " Ø" WIDTH 11 HEIGHT 15 FONT "Calibri" SIZE 8 ACTION Win1.xSPNContr.Value := 0	
			*END WINDOW
			
            DEFINE MAIN MENU OF Win1
				DEFINE POPUP ProgAuthor+SPACE(15)+"Harbour / HMG / Bos Taurus"+SPACE(15)  NAME  POP_01
					MENUITEM "About Bos Taurus..." 	ACTION MsgInfo( BT_InfoName() + "   " + BT_InfoVersion() + CRLF + ;
																	BT_InfoAuthor () + CRLF + "E-MAIL:   srvet@adinet.com.uy" + CRLF + ;
																	"BLOG:     http://srvet.blogspot.com", "Bos Taurus Info" )
					MENUITEM "About Author..." 		ACTION MsgInfo( ProgAuthor + CRLF + ;
																	"Based on: \HMG\3.4.4\SAMPLES\BosTaurus\Demo10.prg "  + CRLF + ;
																	"by Dr. Claudio Soto", "Author Info" )
				END POPUP
				DEFINE POPUP "   ■   FILE  " NAME  LoadSave_FILE
					MENUITEM "LOAD" ACTION ON_INIT()
					MENUITEM "SAVE" ACTION ON_SAVE()
				END POPUP
				DEFINE POPUP "   ■   EFFECTS  " NAME  EFECTOS
					DEFINE POPUP "FAVORITES" NAME  FAVORITES
						MENUITEM "EMBOSS1" 		ACTION Favoritos( 1 )
						MENUITEM "EMBOSS2" 		ACTION Favoritos( 2 )
						MENUITEM "EMBOSS3" 		ACTION Favoritos( 3 )
						MENUITEM "COMICS"   	ACTION Favoritos( 4 ) TOOLTIP "No funciona con Imagenes en Grises"
						MENUITEM "APOCALIPSIS"	ACTION Favoritos( 5 ) TOOLTIP "No funciona con Imagenes en Grises"
						MENUITEM "EDGE ALL" 	ACTION Favoritos( 6 )
						MENUITEM "EDGE INVERT" 	ACTION Favoritos( 7 ) TOOLTIP "No funciona con Imagenes en Grises"
						MENUITEM "ATARDECER" 	ACTION Favoritos( 8 ) TOOLTIP "No funciona con Imagenes en Grises"
						MENUITEM "SEPIA" 		ACTION Favoritos( 9 ) 
						MENUITEM "VERDE NEÓN" 	ACTION Favoritos( 10 ) 
						MENUITEM "ORO" 			ACTION Favoritos( 11 ) TOOLTIP "Funciona mejor con Imagenes en tonos de Grises"
					END POPUP
					SEPARATOR
					SEPARATOR
					MENUITEM "INVERT" 		ACTION { || ChangeImage( ), BT_BitmapInvert( hBitmap ), AplicaFiltro( "INVERT" ) }		
					DEFINE POPUP "EMBOSS" NAME  EMBOSS
						DEFINE POPUP "GRAY" NAME  GRIS
							MENUITEM "EAST" 	ACTION { || ChangeImage( ), weight := 0,  ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 1, 1 ) ), AplicaFiltro( "EMBOSS-GRAY-EAST" ) }
							MENUITEM "NORTH"		ACTION { || ChangeImage( ),weight := 0,  ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 1, 2 ) ), AplicaFiltro( "EMBOSS-GRAY-NORTH" ) }
							MENUITEM "NORTH_EAST"	ACTION { || ChangeImage( ),weight := 0,  ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 1, 3 ) ), AplicaFiltro( "EMBOSS-GRAY-NORTH_EAST" ) }
							MENUITEM "NORTH_WEST"	ACTION { || ChangeImage( ),weight := 0,  ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 1, 4 ) ), AplicaFiltro( "EMBOSS-GRAY-NORTH_WEST" ) }
							MENUITEM "SOUTH"		ACTION { || ChangeImage( ),weight := 0,  ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 1, 5 ) ), AplicaFiltro( "EMBOSS-GRAY-SOUTH" ) }
							MENUITEM "SOUTH_EAST"	ACTION { || ChangeImage( ),weight := 0,  ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 1, 6 ) ), AplicaFiltro( "EMBOSS-GRAY-SOUTH_EAST" ) }
							MENUITEM "SOUTH_WEST"	ACTION { || ChangeImage( ),weight := 0,  ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 1, 7 ) ), AplicaFiltro( "EMBOSS-GRAY-SOUTH_WEST" ) }
							MENUITEM "WEST"		ACTION { || ChangeImage( ),weight := 0,  ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 1, 8 ) ), AplicaFiltro( "EMBOSS-GRAY-WEST" ) }
						END POPUP
						DEFINE POPUP "COLOR" NAME  COLOR
							MENUITEM "EAST" 	ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 1 ) ), AplicaFiltro( "EMBOSS-COLOR-EAST" ) }
							MENUITEM "NORTH "		ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 2 ) ), AplicaFiltro( "EMBOSS-COLOR-NORTH" ) }
							MENUITEM "NORTH_EAST "	ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 3 ) ), AplicaFiltro( "EMBOSS-COLOR-NORTH_EAST" ) }
							MENUITEM "NORTH_WEST "	ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 4 ) ), AplicaFiltro( "EMBOSS-COLOR-NORTH_WEST" ) }
							MENUITEM "SOUTH "		ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 5 ) ), AplicaFiltro( "EMBOSS-COLOR-SOUTH" ) }
							MENUITEM "SOUTH_EAST "	ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 6 ) ), AplicaFiltro( "EMBOSS-COLOR-SOUTH_EAST" ) }
							MENUITEM "SOUTH_WEST "	ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) ), AplicaFiltro( "EMBOSS-COLOR-SOUTH_WEST" ) }
							MENUITEM "WEST "		ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 8 ) ), AplicaFiltro( "EMBOSS-COLOR-WEST" ) }
						END POPUP
						DEFINE POPUP "DARK" NAME  DARK
							MENUITEM "EAST" 	ACTION { || ChangeImage( ), weight := 0, ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 1 ) ), AplicaFiltro( "EMBOSS-DARK-EAST" ) }
							MENUITEM "NORTH "		ACTION { || ChangeImage( ), weight := 0, ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 2 ) ), AplicaFiltro( "EMBOSS-DARK-NORTH" ) }
							MENUITEM "NORTH_EAST "	ACTION { || ChangeImage( ), weight := 0, ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 3 ) ), AplicaFiltro( "EMBOSS-DARK-NORTH_EAST" ) }
							MENUITEM "NORTH_WEST "	ACTION { || ChangeImage( ), weight := 0, ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 4 ) ), AplicaFiltro( "EMBOSS-DARK-NORTH_WEST" ) }
							MENUITEM "SOUTH "		ACTION { || ChangeImage( ), weight := 0, ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 5 ) ), AplicaFiltro( "EMBOSS-DARK-SOUTH" ) }
							MENUITEM "SOUTH_EAST "	ACTION { || ChangeImage( ), weight := 0, ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 6 ) ), AplicaFiltro( "EMBOSS-DARK-SOUTH_EAST" ) }
							MENUITEM "SOUTH_WEST "	ACTION { || ChangeImage( ), weight := 0, ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) ), AplicaFiltro( "EMBOSS-DARK-SOUTH_WEST" ) }
							MENUITEM "WEST "		ACTION { || ChangeImage( ), weight := 0, ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 8 ) ), AplicaFiltro( "EMBOSS-DARK-WEST" ) }
						END POPUP
					END POPUP
					DEFINE POPUP "BLUR" NAME  BLUR
						MENUITEM "VERTICAL" 	ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_BLUR( 1 ) ), AplicaFiltro( "BLUR-VERTICAL" ) }
						MENUITEM "HORIZONTAL"	ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_BLUR( 2 ) ), AplicaFiltro( "BLUR-HORIZONTAL" ) }
						MENUITEM "ANGLE 45"		ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_BLUR( 3 ) ), AplicaFiltro( "BLUR-ANGLE 45" ) }
						MENUITEM "ANGLE 135"	ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_BLUR( 4 ) ), AplicaFiltro( "BLUR-ANGLE 135" ) }
						MENUITEM "ALL DIRECTIONS" ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_BLUR( 5 ) ), AplicaFiltro( "BLUR-ALL DIRECTIONS" ) }
					END POPUP
		// Ponerle un control SPINNER independiente al "GAUSSIANBLUR" ???
					MENUITEM "GAUSSIANBLUR" ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_GaussianBlur( weight ) ), AplicaFiltro( "GAUSSIANBLUR" ) }
														
					DEFINE POPUP "SHARPEN" NAME  SHARPEN
						MENUITEM "VERTICAL" 	ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 1 ) ), AplicaFiltro( "SHARPEN-VERTICAL" ) }
						MENUITEM "HORIZONTAL"	ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) ), AplicaFiltro( "SHARPEN-HORIZONTAL" ) }
						MENUITEM "ANGLE 45"		ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 3 ) ), AplicaFiltro( "SHARPEN-ANGLE 45" ) }
						MENUITEM "ANGLE 135"	ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 4 ) ), AplicaFiltro( "SHARPEN-ANGLE 135" ) }
						MENUITEM "ALL DIRECTIONS" ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 5 ) ), AplicaFiltro( "SHARPEN-ALL DIRECTIONS" ) }
					END POPUP															
		// Ponerle un control SPINNER independiente a los siguientes 3 Efectos ???													
					MENUITEM "SMOOTH" 		 ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_Smooth( weight ) ), AplicaFiltro( "SMOOTH" ) }
					MENUITEM "GAUSSIANSMOOTH" ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_GaussianSmooth( weight ) ), AplicaFiltro( "GAUSSIANSMOOTH" ) }
					MENUITEM "MEANREMOVAL"	 ACTION { || ChangeImage( ), ;
														BT_BitmapConvolutionFilter3x3( hBitmap, BT_MeanRemoval( weight ) ), AplicaFiltro( "MEANREMOVAL" ) }
					DEFINE POPUP "EDGE DETECTION" NAME  EDGEDETECTION
						MENUITEM "DARK"  ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_EdgeDetection1 ), AplicaFiltro( "EDGE DETECTION-DARK" ) }
						MENUITEM "COLOR" ACTION { || ChangeImage( ), ;
													BT_BitmapConvolutionFilter3x3( hBitmap, BT_EdgeDetection2 ), AplicaFiltro( "EDGE DETECTION-COLOR" ) }
					END POPUP	
				END POPUP
				DEFINE POPUP "   ■   EXIT  " NAME  SALIR
					MENUITEM "EXIT" ACTION Win1.release
				END POPUP
				
		// MOSTRAR PATH COMPLETO DEL ARCHIVO EN EDICION	
				@ 002 ,  10 LABEL LB_cFileName VALUE cFileName WIDTH 450 HEIGHT 14 FONT "Calibri" SIZE 8.5 BACKCOLOR aFdoPant FONTCOLOR WHITE
				
		// SATURATION, RED, GREEN, BLUE
				@ 090 , nAncPant-120 SPINNER SPNColGray OF Win1 RANGE 0 , 100 VALUE 0 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "SATURATION" ;
							ITALIC	BACKCOLOR GRAY FONTCOLOR WHITE ON CHANGE { nColGray := Win1.SPNColGray.Value, ChangeImage( ) } INCREMENT 5
				@ 095 , nAncPant-55 LABEL LB_Gray  VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNColGray.Value := 0
				
				@ 125 , nAncPant-120 SPINNER SPNRed   OF Win1 RANGE -255 , 255 VALUE 0 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "RED" ;
							ITALIC	BACKCOLOR RED FONTCOLOR WHITE ON CHANGE { nRed   := Win1.SPNRed.Value, ChangeImage( ) } INCREMENT 5
				@ 130 , nAncPant-55 LABEL LB_Red   VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNRed.Value := 0
									
				@ 160 , nAncPant-120 SPINNER SPNGreen OF Win1 RANGE -255 , 255 VALUE 0 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "GREEN"  ;
							ITALIC	BACKCOLOR GREEN FONTCOLOR WHITE ON CHANGE { nGreen := Win1.SPNGreen.Value, ChangeImage( ) } INCREMENT 5
				@ 165 , nAncPant-55 LABEL LB_Green VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNGreen.Value := 0							
							
				@ 195 , nAncPant-120 SPINNER SPNBlue  OF Win1 RANGE -255 , 255 VALUE 0 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "BLUE"  ;
							ITALIC	BACKCOLOR BLUE FONTCOLOR WHITE ON CHANGE { nBlue  := Win1.SPNBlue.Value, ChangeImage( ) }  INCREMENT 5
				@ 200 , nAncPant-55 LABEL LB_Blue  VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNBlue.Value := 0

		// BRIGHTNESS & CONTRAST
				@ 245 , nAncPant-120 SPINNER SPNBright  OF Win1 RANGE -255 , 255 VALUE 0 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "BRIGHTNESS"  ;
							ITALIC	BACKCOLOR WHITE FONTCOLOR BLACK ON CHANGE { nBright  := Win1.SPNBright.Value, ChangeImage( ) }  INCREMENT 1
				@ 250 , nAncPant-55 LABEL LB_Bright VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNBright.Value := 0								
							
				@ 275 , nAncPant-120 SPINNER SPNContr  OF Win1 RANGE 0 , 135 VALUE 0 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "CONTRAST"  ;
							ITALIC	BACKCOLOR BLACK FONTCOLOR WHITE ON CHANGE { nContr  := Win1.SPNContr.Value, ChangeImage( ) }  INCREMENT 1
				@ 280 , nAncPant-55 LABEL LB_Contr VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNContr.Value := 0	

		// GAMMA
				@ 325 , nAncPant-120 SPINNER SPNRedGa   OF Win1 RANGE 2 , 50 VALUE 10 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "GAMMA RED" ;
							ITALIC	BACKCOLOR { 205, 92, 92 } FONTCOLOR WHITE ON CHANGE { nRedGamma   := Win1.SPNRedGa.Value/10, ChangeImage( ) } INCREMENT 1
				@ 330 , nAncPant-55 LABEL LB_RedGa   VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNRedGa.Value := 10
									
				@ 360 , nAncPant-120 SPINNER SPNGreenGa OF Win1 RANGE 2 , 50 VALUE 10 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "GAMMA GREEN"  ;
							ITALIC	BACKCOLOR { 60, 179, 113 } FONTCOLOR WHITE ON CHANGE { nGreenGamma := Win1.SPNGreenGa.Value/10, ChangeImage( ) } INCREMENT 1
				@ 365 , nAncPant-55 LABEL LB_GreenGa VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNGreenGa.Value := 10							
							
				@ 395 , nAncPant-120 SPINNER SPNBlueGa  OF Win1 RANGE 2 , 50 VALUE 10 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "GAMMA BLUE"  ;
							ITALIC	BACKCOLOR { 30, 144, 255 } FONTCOLOR WHITE ON CHANGE { nBlueGamma  := Win1.SPNBlueGa.Value/10, ChangeImage( ) }  INCREMENT 1
				@ 400 , nAncPant-55 LABEL LB_BlueGa  VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNBlueGa.Value := 10
				
		// STRENGTH para todos los EFECTOS		// CADA EFECTO DEBERÁ LLEVAR SU PROPIO SPINNER ???
				@ 450 , nAncPant-120 SPINNER SPNstrength OF Win1 RANGE 0 , 20 VALUE 1 WIDTH 60 HEIGHT 25 FONT "Calibri" SIZE 12 TOOLTIP "STRENGTH FOR EFFECTS" ;
							ITALIC	BACKCOLOR CYAN FONTCOLOR BLACK ON CHANGE { weight := Win1.SPNstrength.Value, ChangeImage( ) } INCREMENT 1
				@ 455 , nAncPant-55 LABEL LB_strength  VALUE " Ø" WIDTH 14 HEIGHT 14 FONT "Calibri" SIZE 9 ACTION Win1.SPNstrength.Value := 1				
            END MENU
			
		// PORQUÉ EL STATUSBAR SE SOBREPONE EN LA IMAGEN Y PARPADEA ???
			*DEFINE STATUSBAR FONT 'Verdana' SIZE 8
			*	STATUSITEM ""
			*	STATUSITEM ""
			*	DATE WIDTH 80
			*	CLOCK WIDTH 90
			*END STATUSBAR
			SetMenuBkColor( Win1.Handle, { 135, 206, 250 }, .F. )
    END WINDOW
    MAXIMIZE WINDOW Win1
    ACTIVATE WINDOW Win1
RETURN Nil
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION ON_INIT()
	BT_BitmapRelease( hBitmap )
	BT_ClientAreaInvalidateAll( "Win1", .T. )
	cFileName := Getfile( { { 'Files JPG', '*.JPG' }, { 'Files PNG', '*.PNG' } }, 'Open File', cPathIni )
	IF ! EMPTY( cFileName )
		Win1.LB_cFileName.Value := cFileName
		hBitmap_Source := BT_BitmapLoadFile( cFileName )
		IF hBitmap_Source <> 0
			hBitmap := BT_BitmapClone( hBitmap_Source )
			INIC_CTRLS()		// Inicializar Controles al cargar un nuevo archivo		
			ChangeImage( )		//	
		ELSE
			BT_BitmapRelease( hBitmap_Source )
			MSGBOX( "Couldn't open file as a image !" + CRLF + cFileName + CRLF2 +  ;
					"Not Image File OR unsupported file format ! ", "OPEN ERROR !" )
		ENDIF
	ELSE
		MSGBOX( "You did not select any files ...", "LOAD")
	ENDIF
	*DrawGrid()
RETURN Nil
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION ON_RELEASE()
   BT_BitmapRelease( hBitmap )
   BT_BitmapRelease( hBitmap_Source )
RETURN Nil
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION ON_PAINT()
	LOCAL Col    := -Win1.HscrollBar.value
	LOCAL Row    := -Win1.VscrollBar.value
	LOCAL hDC, BTstruct
	hDC := BT_CreateDC( "Win1", BT_HDC_INVALIDCLIENTAREA, @BTstruct )
	BT_DrawBitmap( hDC, Row+20, Col+1, BT_BitmapWidth( hBitmap ), BT_BitmapHeight( hBitmap ), BT_COPY, hBitmap )
	BT_DeleteDC( BTstruct )
RETURN Nil
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION ON_SAVE()
	LOCAL cFileExt  := hb_FNameNameExt( cFileName )
	LOCAL cFile     := Left( cFileExt, At( ".", cFileExt )-1 )
	LOCAL cExt      := Right( cFileExt, 4 )
	LOCAL cFileProc := cFile+"-"+ALLTRIM( STR( DOY( DATE() ) ) )+"-"+STRTRAN(TIME(),":",".")+cExt
	LOCAL cSaveFile := cPathIni+cFileProc
	BT_BitmapSaveFile( hBitmap, cSaveFile, IF( UPPER( cExt ) = ".JPG", BT_FILEFORMAT_JPG, BT_FILEFORMAT_PNG ) )
	MSGBOX( { "The File is Saved in: ", cSaveFile } , "SAVE")
	// Al Guardar, recargar el hBitmap que está en memoria
	hBitmap_Source := BT_BitmapClone( hBitmap )
	hBitmap := BT_BitmapClone( hBitmap_Source )
RETURN Nil
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION ChangeImage( )
	hBitmap := BT_BitmapClone( hBitmap_Source )
	BT_BitmapGrayness( hBitmap, nColGray )
	BT_BitmapModifyColor( hBitmap, nRed, nGreen, nBlue )
	BT_BitmapBrightness( hBitmap, nBright )
	BT_BitmapContrast( hBitmap, nContr )
	BT_BitmapGammaCorrect( hBitmap, nRedGamma, nGreenGamma, nBlueGamma )
	// Si pongo aquí los EFECTOS, se compila bien, pero no se ejecuta el progama ???
	*BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) )
	*BT_BitmapConvolutionFilter3x3( hBitmap, BT_Blur( 2 ) )
	*BT_BitmapConvolutionFilter3x3( hBitmap, {  1,  1,  1,  1,    -8,     1,  1,  1,  1,             0,     0 } )
	BT_ClientAreaInvalidateAll( "Win1", .T. )
RETURN Nil
FUNCTION INIC_CTRLS()
	Win1.SPNColGray.Value	:= 0
	Win1.SPNRed.Value		:= 0
	Win1.SPNGreen.Value		:= 0
	Win1.SPNBlue.Value		:= 0
	Win1.SPNBright.Value	:= 0
	Win1.SPNContr.Value		:= 0
	Win1.SPNRedGa.Value		:= 10
	Win1.SPNGreenGa.Value	:= 10
	Win1.SPNBlueGa.Value	:= 10
	Win1.SPNstrength.Value  := 1
RETURN Nil
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION BT_aFILTER_EMBOSS( nGrayCol, nIndex )
	LOCAL aFILTER, v, add, bias
	DEFAULT nGrayCol := 2
	nweight_ant := weight
	
	IF nGrayCol = 1		// Gray
		v := 1	;	weight := 0	;	add := 0	;	bias := 128
	ELSE				// Color
		v := 3	;	add := 0	;	bias := 0
	ENDIF
	aFILTER := ;
        { { -v,  0,  v, -v,  weight,  v, -v,  0,  v,  weight + add,  bias },; // Right          EAST
          {  v,  v,  v,  0,  weight,  0, -v, -v, -v,  weight + add,  bias },; // Top            NORTH
          {  0,  v,  v, -v,  weight,  v, -v, -v,  0,  weight + add,  bias },; // Top_Right      NORTH_EAST
          {  v,  v,  0,  v,  weight, -v,  0, -v, -v,  weight + add,  bias },; // Top_Left       NORTH_WEST
          { -v, -v, -v,  0,  weight,  0,  v,  v,  v,  weight + add,  bias },; // Bottom         SOUTH
          { -v, -v,  0, -v,  weight,  v,  0,  v,  v,  weight + add,  bias },; // Bottom_Right   SOUTH_EAST 
          {  0, -v, -v,  v,  weight, -v,  v,  v,  0,  weight + add,  bias },; // Bottom_Left    SOUTH_WEST
          {  v,  0, -v,  v,  weight, -v,  v,  0, -v,  weight + add,  bias } } // Left           WEST
		  
	IF nGrayCol = 1		// Gray		// Algo pasa cuando se cambia de GRAY a COLOR.
		Win1.SPNstrength.Value := nweight_ant
		weight := Win1.SPNstrength.Value
	ENDIF
RETURN aFILTER[ nIndex ]
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION BT_aFILTER_BLUR( nIndex ) 
	LOCAL aFILTER
	LOCAL v := 1, add := 2, bias   := 0
	aFILTER := ;
        { {  0,  v,  0,  0,  weight,  0,  0,  v,  0,  weight + add + v * 2,  bias},; // VERTICAL
          {  0,  0,  0,  v,  weight,  v,  0,  0,  0,  weight + add + v * 2,  bias},; // HORIZONTAL
          {  0,  0,  v,  0,  weight,  0,  v,  0,  0,  weight + add + v * 2,  bias},; // ANGLE45 
          {  v,  0,  0,  0,  weight,  0,  0,  0,  v,  weight + add + v * 2,  bias},; // ANGLE135
          {  v,  v,  v,  v,  weight,  v,  v,  v,  v,  weight + add + v * 8,  bias} } // ALLDIRECTIONS 
RETURN aFILTER[ nIndex]
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/

/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION BT_aFILTER_SHARPEN( nIndex ) 
	LOCAL aFILTER
	LOCAL v := 1, add := 0, bias := 0
	aFILTER := ;
        { {  0, -v,  0,  0,  weight,  0,  0, -v,  0,  weight + add - v * 2,  bias},; // VERTICAL
          {  0,  0,  0, -v,  weight, -v,  0,  0,  0,  weight + add - v * 2,  bias},; // HORIZONTAL
          {  0,  0, -v,  0,  weight,  0, -v,  0,  0,  weight + add - v * 2,  bias},; // ANGLE45 
          { -v,  0,  0,  0,  weight,  0,  0,  0, -v,  weight + add - v * 2,  bias},; // ANGLE135
          { -v, -v, -v, -v,  weight, -v, -v, -v, -v,  weight + add - v * 8,  bias} } // ALLDIRECTIONS 
RETURN aFILTER[ nIndex ]
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION AplicaFiltro( cTit )
	IF MsgYesNo( "Do you want to apply the Filter ? ", cTit )
		hBitmap_Source := BT_BitmapClone( hBitmap )
		BT_BitmapRelease( hBitmap )					// 	AÑADÍ ESTO PORQUE EN CIERTO MOMENTO COMO QUE DA ERROR DE MEMORIA
		hBitmap := BT_BitmapClone( hBitmap_Source )
	ELSE
		ChangeImage( )
	ENDIF
RETURN NIL
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
FUNCTION Favoritos( nEfec )		// EFECTOS predefinidos
	DO CASE
	CASE nEfec = 1	//EMBOSS1
		INIC_CTRLS()
		Win1.SPNstrength.Value  := 2
		v := 3	;	weight := 2		;	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) )		// EMBOSS-Bottom_Right-SOUTH_EAST
		v := 1	;	weight := 0		;	add := 0	;	bias := 0
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) )		// Sharpen (Nitidez)-HORIZONTAL
		AplicaFiltro( "EMBOSS1" )
		INIC_CTRLS()
	CASE nEfec = 2	//EMBOSS2
		INIC_CTRLS()
		Win1.SPNstrength.Value  := 4
		v := 3	;	weight := 4		;	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) )		// EMBOSS-Bottom_Right-SOUTH_EAST
		v := 1	;	weight := 0		;	add := 0	;	bias := 0
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) )		// Sharpen (Nitidez)-HORIZONTAL
		AplicaFiltro( "EMBOSS2" )
		INIC_CTRLS()
	CASE nEfec = 3	//EMBOSS3
		INIC_CTRLS()
		Win1.SPNBright.Value	:= -5
		Win1.SPNContr.Value		:= 54
		Win1.SPNstrength.Value  := 4
		v := 3	;	weight := 4		;	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) )		// EMBOSS-Bottom_Right-SOUTH_EAST
		v := 1	;	weight := 0		;	add := 0	;	bias := 0
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) )		// Sharpen (Nitidez)-HORIZONTAL
		AplicaFiltro( "EMBOSS3" )
		INIC_CTRLS()
	CASE nEfec = 4	//COMICS 
		INIC_CTRLS()
		Win1.SPNRed.Value		:= 30
		Win1.SPNGreen.Value		:= 30
		Win1.SPNContr.Value		:= 60
		Win1.SPNstrength.Value  := 5
		v := 3	;	weight := 5		;	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) )		// EMBOSS-Bottom_Right-SOUTH_EAST
		v := 1	;	weight := 0		;	add := 0	;	bias := 0
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) )		// Sharpen (Nitidez)-HORIZONTAL
		AplicaFiltro( "COMICS" )
		INIC_CTRLS()
	CASE nEfec = 5	//APOCALIPSIS
		INIC_CTRLS()
		Win1.SPNColGray.Value	:= 55
		Win1.SPNRed.Value		:= 65
		Win1.SPNBlue.Value		:= 55
		Win1.SPNBright.Value	:= -35
		Win1.SPNContr.Value		:= 60
		Win1.SPNBlueGa.Value	:= 12
		Win1.SPNstrength.Value  := 4
		v := 3	;	weight := 4		;	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) )		// EMBOSS-Bottom_Right-SOUTH_EAST
		v := 1	;	weight := 0		;	add := 0	;	bias := 0
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) )		// Sharpen (Nitidez)-HORIZONTAL
		AplicaFiltro( "APOCALIPSIS" )
		INIC_CTRLS()
	CASE nEfec = 6	//EDGE ALL
		INIC_CTRLS()
		ChangeImage( )
		*v := 3	;	weight := 2,	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_EdgeDetection2 )		// Detects Edges Execessively
		AplicaFiltro( "EDGE ALL" )
		INIC_CTRLS()
	CASE nEfec = 7	//EDGE INVERT
		INIC_CTRLS()
		Win1.SPNColGray.Value	:= 55
		Win1.SPNRed.Value		:= 65
		Win1.SPNBlue.Value		:= 55
		Win1.SPNBright.Value	:= -35
		Win1.SPNContr.Value		:= 60
		Win1.SPNBlueGa.Value	:= 12
		Win1.SPNstrength.Value  := 4
		v := 3	;	weight := 4		;	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) )		// EMBOSS-Bottom_Right-SOUTH_EAST
		v := 1	;	weight := 0		;	add := 0	;	bias := 0
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) )		// Sharpen (Nitidez)-HORIZONTAL
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_EdgeDetection1 )				// Detects Edges Execessively
		AplicaFiltro( "EDGE INVERT" )
		INIC_CTRLS()
	CASE nEfec = 8	//ATARDECER		
		INIC_CTRLS()
		Win1.SPNColGray.Value	:= 0
		Win1.SPNRed.Value		:= 45
		Win1.SPNGreen.Value		:= 0
		Win1.SPNBlue.Value		:= 0
		Win1.SPNBright.Value	:= -26
		Win1.SPNContr.Value		:= 60
		Win1.SPNRedGa.Value		:= 2
		Win1.SPNGreenGa.Value	:= 10
		Win1.SPNBlueGa.Value	:= 10
		Win1.SPNstrength.Value  := 1
		AplicaFiltro( "ATARDECER" )
		INIC_CTRLS()
	CASE nEfec = 9	//SEPIA		
		INIC_CTRLS()
		Win1.SPNColGray.Value	:= 100
		Win1.SPNRed.Value		:= 0
		Win1.SPNGreen.Value		:= 30
		Win1.SPNBlue.Value		:= 0
		Win1.SPNBright.Value	:= -29
		Win1.SPNContr.Value		:= 33
		Win1.SPNRedGa.Value		:= 5
		Win1.SPNGreenGa.Value	:= 7
		Win1.SPNBlueGa.Value	:= 10
		Win1.SPNstrength.Value  := 1
		AplicaFiltro( "SEPIA1" )	;	INSERTENTER()	// FORZAR UN ENTER PARA QUE NO SE VEA LA VENTANA
		Win1.SPNColGray.Value	:= 0
		Win1.SPNRed.Value		:= 0
		Win1.SPNGreen.Value		:= 0
		Win1.SPNBlue.Value		:= 0
		Win1.SPNBright.Value	:= -10
		Win1.SPNContr.Value		:= 41
		Win1.SPNRedGa.Value		:= 10
		Win1.SPNGreenGa.Value	:= 10
		Win1.SPNBlueGa.Value	:= 11
		Win1.SPNstrength.Value  := 1		
		AplicaFiltro( "SEPIA2" )
		INIC_CTRLS()
	CASE nEfec = 10		//VERDE NEÓN		
		INIC_CTRLS()
		Win1.SPNColGray.Value	:= 100
		Win1.SPNRed.Value		:= 0
		Win1.SPNGreen.Value		:= 45
		Win1.SPNBlue.Value		:= 0
		Win1.SPNBright.Value	:= -18
		Win1.SPNContr.Value		:= 70
		Win1.SPNRedGa.Value		:= 2
		Win1.SPNGreenGa.Value	:= 9
		Win1.SPNBlueGa.Value	:= 2
		Win1.SPNstrength.Value  := 1
		AplicaFiltro( "VERDE NEÓN" )
		INIC_CTRLS()
	CASE nEfec = 11		//ORO		
		INIC_CTRLS()
		// EMBOSS3
		Win1.SPNBright.Value	:= -5
		Win1.SPNContr.Value		:= 54
		Win1.SPNstrength.Value  := 4
		v := 3	;	weight := 4		;	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_EMBOSS( 2, 7 ) )		// EMBOSS-Bottom_Right-SOUTH_EAST
		v := 1	;	weight := 0		;	add := 0	;	bias := 0
		ChangeImage( )
		// SHARPEN
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) )		// Sharpen (Nitidez)-HORIZONTAL
*		AplicaFiltro( "EMBOSS3" ) ;	INSERTENTER()
		// SEPIA
		Win1.SPNColGray.Value	:= 100
		Win1.SPNRed.Value		:= 0
		Win1.SPNGreen.Value		:= 30
		Win1.SPNBlue.Value		:= 0
		Win1.SPNBright.Value	:= -29
		Win1.SPNContr.Value		:= 33
		Win1.SPNRedGa.Value		:= 5
		Win1.SPNGreenGa.Value	:= 7
		Win1.SPNBlueGa.Value	:= 10
		Win1.SPNstrength.Value  := 1
		ChangeImage( )
		AplicaFiltro( "SEPIA1" )	;	INSERTENTER()		// PORQUE SE DESPLIEGA ESTA VENTANA ???	
		Win1.SPNColGray.Value	:= 0
		Win1.SPNRed.Value		:= 0
		Win1.SPNGreen.Value		:= 0
		Win1.SPNBlue.Value		:= 0
		Win1.SPNBright.Value	:= -10
		Win1.SPNContr.Value		:= 41
		Win1.SPNRedGa.Value		:= 10
		Win1.SPNGreenGa.Value	:= 10
		Win1.SPNBlueGa.Value	:= 11
		Win1.SPNstrength.Value  := 1	
		ChangeImage( )
*		AplicaFiltro( "SEPIA2" )	;	INSERTENTER()
		// + CONTRASTE
		INIC_CTRLS()
		Win1.SPNBright.Value	:= 20
		Win1.SPNContr.Value		:= 60
		Win1.SPNstrength.Value  := 4
		v := 1	;	weight := 4		;	add := 0	;	bias := 0
		ChangeImage( )
		BT_BitmapConvolutionFilter3x3( hBitmap, BT_aFILTER_SHARPEN( 2 ) )		// Sharpen (Nitidez)-VERTICAL
		AplicaFiltro( "ORO" )
		INIC_CTRLS()
	ENDCASE
RETURN NIL
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/

/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/

/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
*Procedure DrawGrid()
*	PUBLIC DesignFormhandle := 0
*	DesignFormHandle := GetFormHandle ( "Win1" )
*	DRAWDESIGNGRID( DesignFormHandle , GetWindowHeight( DesignFormhandle ) , GetWindowWidth( DesignFormhandle) )
*Return
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
#pragma BEGINDUMP

    #define _WIN32_IE      0x0500
    #define HB_OS_WIN_32_USED

    #include <windows.h>
    #include <commctrl.h>
    #include "hbapi.h"
    #include "hbvm.h"
    #include "hbstack.h"
    #include "hbapiitm.h"
    #include "winreg.h"
    #include "tchar.h"
    #include <shlobj.h>
	#include <wingdi.h>
    #include <winuser.h>
    #include <vfw.h>
    #include <windowsx.h>
//------------------------------------------------------------------------------
	#include "SET_COMPILE_HMG_UNICODE.ch"
	#include "HMG_UNICODE.h"

    HB_FUNC ( INSERTENTER )
    {
	   keybd_event(
			VK_RETURN	,	// virtual-key code
			0,		// hardware scan code
			0,		// flags specifying various function options
			0		// additional data associated with keystroke
				);
    }

	HB_FUNC ( DRAWDESIGNGRID )
	{
		int r , c , rto , cto ;
		HWND hWnd1;
		HDC hdc1;
		HGDIOBJ hgdiobj1;
		HPEN hpen;
		hWnd1 = (HWND) HMG_parnl(1);
		hdc1 = GetDC( (HWND) hWnd1 );
		hpen = CreatePen( (int) PS_SOLID, (int) 1 , (COLORREF) RGB( (int) 0, (int) 0, (int) 0 ) );
		hgdiobj1 = SelectObject( (HDC) hdc1, hpen );
		rto = hb_parni(2);
		cto = hb_parni(3);
	
		for ( r=10 ; r<=rto; r+=10 )
		{
			for ( c=10 ; c<=cto ; c+=10 )
			{
				MoveToEx( (HDC) hdc1, (int) c, (int) r, NULL );
				LineTo( (HDC) hdc1, (int) c+1, (int) r+1 );
			}
		}
	
		SelectObject( (HDC) hdc1, (HGDIOBJ) hgdiobj1 );
		DeleteObject( hpen );
		ReleaseDC( hWnd1, hdc1 );
	}


	HB_FUNC ( REDRAWRECT )
	{
		RECT r;
		
		r.top 	= hb_parni(2) ;
		r.left 	= hb_parni(3) ;
		r.bottom= hb_parni(4) ;
		r.right	= hb_parni(5) ;
	
		RedrawWindow(
			(HWND) HMG_parnl( 1 ),	
			&r,	
			NULL,	
			RDW_ERASE | RDW_INVALIDATE | RDW_ERASENOW | RDW_UPDATENOW
		);
	}

	HB_FUNC ( DRAWDESIGNGRIDRECT )
	{
		int r , c , rto , cto , rfrom , cfrom ;
		HWND hWnd1;
		HDC hdc1;
		HGDIOBJ hgdiobj1;
		HPEN hpen;
		hWnd1 = (HWND) HMG_parnl(1);
		hdc1 = GetDC( (HWND) hWnd1 );
		hpen = CreatePen( (int) PS_SOLID, (int) 1 , (COLORREF) RGB( (int) 0, (int) 0, (int) 0 ) );
		hgdiobj1 = SelectObject( (HDC) hdc1, hpen );
	
		rfrom = hb_parni(2);
		cfrom = hb_parni(3);
	
		rto = hb_parni(4);
		cto = hb_parni(5);
	
		for ( r=rfrom ; r<=rto; r+=10 )
		{
			for ( c=cfrom ; c<=cto ; c+=10 )
			{
				MoveToEx( (HDC) hdc1, (int) c, (int) r, NULL );
				LineTo( (HDC) hdc1, (int) c+1, (int) r+1 );
			}
		}
	
		SelectObject( (HDC) hdc1, (HGDIOBJ) hgdiobj1 );
		DeleteObject( hpen );
		ReleaseDC( hWnd1, hdc1 );
	}

	HB_FUNC ( REDRAWALL )
	{
		RedrawWindow(
			(HWND) HMG_parnl( 1 ),	
			NULL,	
			NULL,	
			RDW_ERASE | RDW_INVALIDATE | RDW_ERASENOW 
		);
	}

#pragma ENDDUMP
/*[•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•.•]*/
